﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class SetCarsGeneric<T>
    where T : class
    {
        /// <summary>
        /// Массив объектов, которые храним
        /// </summary>
        private readonly T[] _places;
        /// <summary>
        /// Количество объектов в массиве
        /// </summary>
        public int Count => _places.Length;
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="count"></param>
        public SetCarsGeneric(int count)
        {
            _places = new T[count];
        }
        public int Insert(T car)
        {
            // TODO вставка в начало набора
            for(int i = 0; i < _places.Length; i++)
            {
                if (_places[i] == null)
                {
                    _places[i] = car;
                    return i;
                }
            }
            return -1;
        }
        public int Insert(T car, int position)
        {
            // TODO проверка позиции
            // TODO проверка, что элемент массива по этой позиции пустой, если нет, то
            // проверка, что после вставляемого элемента в массиве есть пустой элемент
            // сдвиг всех объектов, находящихся справа от позиции до первого пустого элемента
            // TODO вставка по позиции

            int index = position;

            while (_places[index] != null && index < _places.Length) index++;

            if (index == _places.Length) return -1;
            for (int i = index; i > position; --i) _places[i] = _places[i - 1];

            _places[position] = car;
            return position;
        }
        /// <summary>
        /// Удаление объекта из набора с конкретной позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Remove(int position)
        {
            // TODO проверка позиции
            // TODO удаление объекта из массива, присовив элементу массива значение null
            T res = _places[position];
            _places[position] = null;
            return res;
        }
        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Get(int position)
        {
            // TODO проверка позиции
            return _places[position];
        }
    }

}
